// August 18, 2008 
// implements Paar Heuristic

#include <math.h>
#include <ctype.h>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>

using namespace std;
void ReadNextMatrix(void);
void doResidualMatrix(void);
int FindBestPair(int *ci, int *cj);
int countPairs(int c1, int c2);
void UpdateA(int c1, int c2);
void DoMatrix();

ifstream X_file;
//ofstream depth_file;

const int MAX_ROWS = 100;
const int MAX_COLUMNS = 100;
int num_rows;
int num_columns;
int TotalGateCount;

int A[MAX_ROWS][MAX_COLUMNS];

int main(int argc, char *argv[])
{
  int NumMatrices; 
 
  clock_t t1=clock();
  X_file.open("matrices/matrices34.20.20");
  //X_file.open("baaaaad");
  //X_file.open("matrices");
  //X_file.open("matrices/matrices.9.15.15");
  X_file >> NumMatrices;
  for (int i = 0; i < NumMatrices; i++) DoMatrix();
  X_file.close();
  clock_t t2=clock();
  cout << (t2-t1)/(double)CLOCKS_PER_SEC;
}

void DoMatrix()
{
  TotalGateCount = 0;
  ReadNextMatrix();
  int ci, cj;
  int count; 
  count = FindBestPair(&ci, & cj);
  while (count > 1)
  {
    TotalGateCount++;
    UpdateA(ci,cj);
    //print the chosen pair of indices 
    //cout << ci << " + " << cj << endl; 
    count = FindBestPair(&ci, & cj);
  } 
  doResidualMatrix();
  //cout << "Total gate count is " ;
  cout << TotalGateCount << endl;
}//DoMatrix

void UpdateA(int c1, int c2)
{
  //add a column
  num_columns++;
  for (int row = 0; row < num_rows; row++)
  {
    if ( (A[row][c1] == 1) && (A[row][c2] == 1) ) 
    {
      A[row][num_columns - 1] = 1;
      A[row][c1] = 0;
      A[row][c2] = 0;
    }
    else A[row][num_columns - 1] = 0;
  }
}

// finds two column indices ci, cj of global matrix A[][]
// that maximize the number (bestcount) of rows r for which 
// both entries A[r][ci] and A[r][cj] are 1.
// Returns bestcount.
// No secondary tie resolution is used: sticks with the 
// first optimum columns found.

int FindBestPair(int * ci, int * cj)
{
  int bestci = -1;
  int bestcj = -1;
  int bestcount = -1;
  int thiscount;
  for (int c1 = 0; c1 < num_columns; c1++)
  for (int c2 = c1 + 1; c2 < num_columns; c2++)
  {
    thiscount = countPairs(c1,c2);
    if (thiscount > bestcount)
    {
      bestci = c1;
      bestcj = c2;
      bestcount = thiscount;
    }
  }      
  (*ci) = bestci;
  (*cj) = bestcj;
  return bestcount;
}

int countPairs(int c1, int c2)
{
  int count = 0;
  for (int i = 0; i < num_rows; i++)
    if ( (A[i][c1] == 1) && (A[i][c2] == 1) ) count++;
  return count;
}

// the residual matrix is the one where no more
// common sums are present. This computes the
// number of gates necessary to build the corresponding
// circuit. It can also print the matrix
// (this is currently commented out).

void doResidualMatrix(void)
{
  int h;
  for (int row = 0; row < num_rows; row++)
  {
    h = 0;
    for (int col = 0; col < num_columns; col++)
    {
      h = h + A[row][col]; 
      // cout << A[row][col] << " ";
    }
    //cout << "   weight is " << h << endl;
    TotalGateCount = TotalGateCount + h - 1;
  }
}

void ReadNextMatrix(void)
{
  X_file >> num_rows; 
  X_file >> num_columns;
  for (int row = 0; row < num_rows; row++)
  for (int col = 0; col < num_columns; col++)
  X_file >> A[row][col];
}


